// MediaGrabber.h: CMediaGrabber NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_MEDIAGRABBER_H_)
#define _MEDIAGRABBER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IMediaDecoder.h"


/////////////////////////////////////////////////////////////////////////////
// TvOo(Otʉ߂CMediaDataɃANZXi񋟂)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CMediaData		̓f[^
// Output	#0	: CMediaData		o̓f[^
/////////////////////////////////////////////////////////////////////////////

class CMediaGrabber : public IMediaDecoder  
{
public:
	typedef void (CALLBACK * MEDIAGRABFUNC)(const CMediaData *pMediaData, const PVOID pParam);	// fBA󂯎R[obN^
	typedef void (CALLBACK * RESETGRABFUNC)(const PVOID pParam);								// Zbg󂯎R[obN^

	CMediaGrabber();
	virtual ~CMediaGrabber();

// IMediaDecoder
	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0);

// CMediaGrabber
	void SetMediaGrabCallback(const MEDIAGRABFUNC pCallback, const PVOID pParam = NULL);
	void SetResetGrabCallback(const RESETGRABFUNC pCallback, const PVOID pParam = NULL);

protected:
	MEDIAGRABFUNC m_pfnMediaGrabFunc;
	RESETGRABFUNC m_pfnResetGrabFunc;

	PVOID m_pMediaGrabParam;
	PVOID m_pResetGrabParam;
};

#endif // !defined(_MEDIAGRABBER_H_)
